import { fetchAllLocations } from '@/app/lib/actions/locationActions';
import { fetchAvailableYears } from '@/app/lib/actions/monthActions';
import { BillingLocation, YearMonth } from '@/app/lib/db-types';
import { FC } from 'react';
import { MonthLocationList } from '@/app/ui/MonthLocationList';

export interface HomePageProps {
  searchParams?: {
    year?: string;
    month?: string;
  };
}

export const HomePage:FC<HomePageProps> = async ({ searchParams }) => {

  let availableYears: number[];

  // const asyncTimout = (ms:number) => new Promise(resolve => setTimeout(resolve, ms));
  // await asyncTimout(5000);

  try {
    availableYears = await fetchAvailableYears();
  } catch (error:any) {
    return (
      <main className="flex min-h-screen flex-col p-6 bg-base-300">
        <p className="text-center text-2xl text-red-500">{error.message}</p>
      </main>);
  }

  // if the database is in it's initial state, show the add location button for the current month
  if(availableYears.length === 0) {
    return (<MonthLocationList />);
  }

  const currentYear = Number(searchParams?.year) || new Date().getFullYear();
  
  const locations = await fetchAllLocations(currentYear);

  // group locations by month
  const months = locations.reduce((acc, location) => {
    const {year, month} =  location.yearMonth;
    const key = `${year}-${month}`;

    const locationsInMonth = acc[key];

    if(locationsInMonth) {
      return({
        ...acc,
        [key]: {
          yearMonth: location.yearMonth,
          locations: [...locationsInMonth.locations, location],
          monthlyExpense: locationsInMonth.monthlyExpense + location.bills.reduce((acc, bill) => bill.paid ? acc + (bill.payedAmount ?? 0) : acc, 0)
        }
      })
    }

    return({
      ...acc,
      [key]: {
        yearMonth: location.yearMonth,
        locations: [location],
        monthlyExpense: location.bills.reduce((acc, bill) => bill.paid ? acc + (bill.payedAmount ?? 0) : acc, 0)
      }
    });
  }, {} as {[key:string]:{
    yearMonth: YearMonth,
    locations: BillingLocation[],
    monthlyExpense: number
  } });

 return (
    <MonthLocationList availableYears={availableYears} months={months} />
  );
}

export default HomePage;